#!/usr/bin/env python


class Complex(object):
    def __init__(self, re=0.0, im=0.0):
        self.re = re
        self.im = im

    def __mul__(self, x):
        if isinstance(x, float):
            x = Complex(x, 0.0)
        return Complex(re=self.re*x.re - self.im * x.im,
                       im=self.re*x.im + self.im * x.re)

    def __rmul__(self, x):
        return self * x

    def __imul__(self, x):
        if isinstance(x, float):
            x = Complex(x, 0.0)
        re=self.re*x.re - self.im * x.im
        im=self.re*x.im + self.im * x.re
        self.re = re
        self.im = im
        return self

    def __str__(self):
        return "{self.re}{self.im:+}j".format(self=self)

    def __repr__(self):
        return "Complex(re={}, im={})".format(self.re, self.im)
