/* File : complex.cpp */

#include <cmath>

#include "complex/complex.h"

Complex Complex::operator *(const Complex & z) const
{
    return Complex(this->real() * z.real() - this->imag() * z.imag(),
                   this->real() * z.imag() + this->imag() * z.real());
}

Complex Complex::operator +(const Complex & z) const
{
    return Complex(this->real() + z.real(), this->imag() + z.imag());
}

double Complex::mod() const
{
    return sqrt(this->m_re * this->m_re + this->m_im * this->m_im);
}

std::ostream & operator <<(std::ostream & os, const Complex & z)
{
    os << z.real() << std::showpos << z.imag() << 'j';
    return os;
}
