#!/usr/bin/env python

"""Some functions to work with divisors"""


def divisors(N):
    """Returns all divisors of N.

    >>> divisors(2009)
    (7, 41, 49, 287)

    """
    l = []
    for i in range(2, N):
        if N % i == 0:
            l.append(i)
    return tuple(l)
    

def is_prime(N):
    """Returns True if N is prime.

    >>> is_prime(2)
    True
    >>> is_prime(9)
    False

    """
    for i in range(2, N):
        if N % i == 0:
            return False
    else:
        return True


def prime_divisors(N):
    """Returns all prime divisors of N.

    >>> prime_divisors(2009)
    (7, 41)

    """
    l = [] 
    for i in divisors(N):
        if is_prime(i):
            l.append(i)
    return tuple(l)
    

def next_prime(N):
    """Return the first prime > N

    >>> next_prime(5)
    7
    >>> next_prime(8)
    11

    """
    p = N + 1
    while not is_prime(p):
        p += 1
    return p


def primes(N):
    """Returns all primes <= N

    >>> primes(10)
    (2, 3, 5, 7)

    """
    p = 2
    l = []
    while p <= N:
        l.append(p)
        p = next_prime(p)
    return tuple(l)


if __name__ == "__main__":
    import doctest
    doctest.testmod()



